<template>
  <v-container
    fluid
    pa-0
    ma-0
  >
    <v-card
      :height="vH"
    >
      <v-row>
        <v-col
          cols="12"
          class="text-center"
        >
          <h1> Open Purchase Orders </h1>
        </v-col>
      </v-row>
      <v-row>
        <!-- style="visibility: hidden;" -->
        <v-col
          class="mx-3"
          cols="2"
          style="visibility: hidden;"
        >
          <v-radio-group
            v-model="focusType"
            readonly
            row
          >
            <v-radio
              label="Unit - District"
              value="DST"
            />
            <v-radio
              label="Age Spread - District"
              value="RNG"
            />
          </v-radio-group>
        </v-col>
        <v-col

          cols="1"
        >
          <v-select
            v-model="jlu"
            :items="unitList"
            item-value="unit"
            item-text="unit"
            label="Default JLU"
            clearable
          />
        </v-col>
        <v-col
          class="mx-3"
          cols="2"
        >
          <v-select
            v-model="teamSel"
            :items="teamsFiltered"
            label="Teams"
            item-value="teamId"
            item-text="teamId"
            multiple
            clearable
          />
        </v-col>
        <v-col
          cols="3"
        >
          <v-radio-group
            v-model="fmsIncl"
            row
          >
            <v-radio
              label="Exclude FMS"
              value="exFMS"
            />
            <v-radio
              label="Include FMS"
              value="incFMS"
            />
            <v-radio
              label="Just FMS"
              value="justFMS"
            />
          </v-radio-group>
        </v-col>
        <v-col
          v-if="expAPerc === 0 || expAPerc >99.9"
          cols="2"
        >
          <v-btn
            color="primary"
            :loading="expALoading"
            @click="exportAll()"
          >
            Export All Data
          </v-btn>
        </v-col>
        <v-col
          v-if="expAPerc > 0 && expAPerc <99.9"
          cols="2"
        >
          <v-progress-circular
            :rotate="360"
            :size="65"
            :width="4"
            :value="expAPerc"
            color="primary"
          >
            {{ expAPerc }}
          </v-progress-circular>
        </v-col>
      </v-row>
      <!-- <v-row>
        <v-col
          v-if="gTg === true"
          class="ma-5"
          cols="12"
        >
          ds Length {{ dataSet.length }}<br>
          jlu: {{ jlu }}<br>
          cL prop: {{ cL }}<br>
          topClick: {{ topClick }} <br>
          teams: {{ teams.length }}<br>
          teamSel: {{ teamSel }}<br>
        </v-col>
      </v-row> -->
      <v-row>
        <v-col
          cols="1"
        />
        <v-col
          v-if="showChart = true"
          class="px-3"
          cols="10"
        >
          <highcharts
            :options="chartOptions"
            class="chart"
          />
        </v-col>
        <v-col
          cols="1"
        >
          <v-btn
            v-if="cL==='D'"
            color="blue darken-1"
            @click="clickBack()"
          >
            Back
          </v-btn>
        </v-col>
      </v-row>
    </v-card>
    <v-dialog
      v-model="opnRptD"

      :max-width="`${vW2}`"
    >
      <v-card
        :min-height="`${vHR}`"
        class="px-3"
      >
        <v-card-title class="text-h5">
          {{ rptTitle }}
        </v-card-title>
        <v-card-actions>
          <v-row>
            <v-col
              cols="9"
            />
            <v-col
              v-if="rptPerc === 0 || rptPerc > 99.9"
              cols="2"
            >
              <v-btn
                color="primary"
                :loading="dlProcess"
                @click="download()"
              >
                Download
              </v-btn>
            </v-col>
            <v-col
              v-if="rptPerc > 0 && rptPerc <99.9"
              cols="2"
            >
              <v-progress-circular
                :rotate="360"
                :size="65"
                :width="4"
                :value="rptPerc"
                color="primary"
              >
                {{ rptPerc }}
              </v-progress-circular>
            </v-col>
            <v-col
              cols="1"
            >
              <v-btn
                color="primary"

                @click="closeRpt()"
              >
                Close
              </v-btn>
            </v-col>
          </v-row>
          <v-row>
            <v-col
              cols="2"
            />
            <v-col
              cols="3"
            >
              <v-text-field
                v-model="rptSearch"
                clearable
                label="Text Search"
                hint="Note, not all fields are used for the search"
              />
            </v-col>
          </v-row>
        </v-card-actions>
        <v-card-text>
          <!-- The rpt meta is: {{ rptDataMeta }}<br>
          sortBy: {{ rptSortBy }}<br>
          rptPage: {{ rptPage }}<br>
          pageCount: {{ pageCount }}<br>
          rptDataSet: {{ rptDataSet.length }}<br>
          jlu: {{ jlu }}<br>
          cL prop: {{ cL }}<br>
          topClick: {{ topClick }} <br>
          name: {{ name }}<br>
          unit: {{ unit }}<br>
          teams: {{ teams.length }}<br>
          teamSel: {{ teamSel }}<br>
          fT: {{ focusType }} -->
        </v-card-text>

        <v-row
          v-if="rptDataSet !== undefined &&
            rptDataSet.length > 0"
          class="px-3"
        >
          <v-col

            class="ma-2"
          >
            <v-data-table
              :headers="headersRpt"
              :items="rptDataSet"
              :loading="rptLoading"
              :server-items-length="rptTotalItems"
              :page.sync="rptPage"
              :sort-by.sync="rptSortBy"
              :sort-desc.sync="rptSortByDesc"
              :items-per-page="itemsPerPage"
              class="elevation-1"
              must-sort
              @page-count="pageCount = $event"
              @sort-by="sortBy = $event"
            >
              <!-- eslint-disable-next-line -->
            <template v-slot:item.lineValue="{ item }">
                {{ item.lineValue | toDollars }}
              </template>
              <!-- eslint-disable-next-line -->
            <template v-slot:item.currNetPrI="{ item }">
                {{ item.currNetPrI | toDollars }}
              </template>
              <!-- eslint-disable-next-line -->
              <template v-slot:item.dateExtract="{ item }">
                {{ item.dateExtract | shortenedDate }}
              </template>
              <!-- eslint-disable-next-line -->
              <template v-slot:item.creationDate="{ item }">
                {{ item.creationDate | shortenedDate }}
              </template>

              <!-- eslint-disable-next-line -->
              <template v-slot:item.onstRcptDate ="{ item }">
                {{ item.onstRcptDate | shortenedDate }}
              </template>
              <!-- eslint-disable-next-line -->
              <template v-slot:item.currDueDate ="{ item }">
                {{ item.currDueDate | shortenedDate }}
              </template>
            </v-data-table>
          </v-col>
        </v-row>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>

// eslint-disable-next-line
import { patch, post, get, getBulkData, exportBulkExcel } from 'kyd-utils';
import {
  cloneDeep, uniqBy, orderBy, isEqual,
} from 'lodash';
import { EventBus } from '../localUtils/eventBus';
// eslint-disable-next-line
// eslint-disable-next-line
import { dateShortFromLong, dateFddmmmyy, dateFyymmdd, dateOnly, dateISOShort } from '../localUtils';

export default {
  components: {
  },
  filters: {
    toDollars(val) {
      return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    },
  },
  props: {
    cL: {
      type: String,
      default: 'T',
    },
    unit: {
      type: String,
      default: '',
    },
    actionCall: {
      type: String,
      default: '',
    },
    name: {
      type: String,
      default: '',
    },
    topClick: {
      type: String,
      default: null,
    },
  },
  data: () => ({
    dataSet: [],
    rptDataSet: [],
    rptTitle: '',
    opnRptD: false,
    rptDataMeta: {
      totalItems: 0,
      itemsPerPage: 10,
      sort: [{ asc: true, key: 'poNo' }],
      sortBy: ['poNo'],
      sortDesc: [false],
      page: 1,
    },
    rptPerc: 0,
    rptLoading: false,
    pageCount: 0,
    itemsPerPage: 10,
    gTg: false,
    showChart: false,
    teams: [],
    teamSel: [],
    fmsIncl: 'exFMS',
    jlu: '',
    focusType: 'DST',
    dlProcess: false,
    headersRptDL: [
      {
        title: 'Unit',
        key: 'unit',
      },
      {
        title: 'District Code',

        key: 'dstrctCode',
      },
      {
        title: 'Whouse ID',

        key: 'whouseId',
      },
      {
        title: 'PO No',

        key: 'poNo',
      },
      {
        title: 'PO Item No',

        key: 'poItemNo',
      },
      {
        title: 'PO Type',

        key: 'poType',
      },
      {
        title: 'ReceivingRptNarrativeText',

        key: 'receivingRptNarrativeText',
      },
      {
        title: 'PREQ StkCode',
        key: 'preqStkCode',
      },
      {
        title: 'Item Name',

        key: 'itemName',
      },
      {
        title: 'Qty Outstanding',

        key: 'qtyOutstanding',
      },
      {
        title: 'Line key',

        key: 'linekey',
      },
      {
        title: 'SIO',

        key: 'sio',
      },
      {
        title: 'Pd Schedule',

        key: 'pdS',
      },
      {
        title: 'Creation Date',

        key: 'creationDate',
      },
      {
        title: 'Curr DueDate',

        key: 'currDueDate',
      },
      {
        title: 'Days Past DDate',

        key: 'daysPastDuedate',
      },
      {
        title: 'Due Date Range',

        key: 'dueDateAgeRange',
      },
      {
        title: 'Purch Officer',

        key: 'purchOfficer',
      },
      {
        title: 'Team Id',

        key: 'teamId',
      },
      {
        title: 'Supplier No',

        key: 'supplierNo',
      },
      {
        title: 'Supplier Name',

        key: 'supplierName',
      },
      {
        title: 'Inspection Code',

        key: 'inspectCode',
      },
      {
        title: 'Current Net Price',

        key: 'currNetPrI',
      },
      {
        title: 'Inv Ref',

        key: 'invoiceRef',
      },
      {
        title: 'Onst Recpt Date',

        key: 'onstRcptDate',
      },
      {
        title: 'PRC Code',

        key: 'prcCde',
      },
      {
        title: 'Stock Type',

        key: 'stockType',
      },
      {
        title: 'ACCC',

        key: 'accc',
      },
      {
        title: 'WBS',

        key: 'wbs',
      },
      {
        title: 'Fund',

        key: 'fund',
      },
      {
        title: 'Del Loc',

        key: 'delivLocation221',
      },
      {
        title: 'Date Extract Milis',

        key: 'dateExtract',
      },
    ],
    headersRpt: [
      {
        text: 'Unit',
        align: 'start',
        // width: '10%',
        value: 'unit',
      },
      {
        text: 'District Code',
        align: 'start',
        // width: '10%',
        value: 'dstrctCode',
      },
      {
        text: 'Whouse ID',
        // width: '30%',
        value: 'whouseId',
      },
      {
        text: 'PO No',
        align: 'end',
        // width: '10%',
        value: 'poNo',
      },
      {
        text: 'PO Item No',
        align: 'end',
        // width: '15%',
        value: 'poItemNo',
      },
      {
        text: 'PO Type',
        align: 'end',
        // width: '15%',
        value: 'poType',
      },
      {
        text: 'ReceivingRptNarrativeText',
        align: 'start',
        // width: '15%',
        value: 'receivingRptNarrativeText',
      },
      {
        text: 'PREQ StkCode',
        align: 'start',
        // width: '15%',
        value: 'preqStkCode',
      },
      {
        text: 'Item Name',
        align: 'start',
        // width: '10%',
        value: 'itemName',
      },
      {
        text: 'Qty Outstanding',
        align: 'end',
        // width: '10%',
        value: 'qtyOutstanding',
      },
      {
        text: 'Line Value',
        align: 'end',
        // width: '10%',
        value: 'lineValue',
      },
      {
        text: 'SIO',
        align: 'start',
        // width: '30%',
        value: 'sio',
      },
      {
        text: 'Pd Schedule',
        align: 'start',
        // width: '10%',
        value: 'pdS',
      },
      {
        text: 'Creation Date',
        align: 'end',
        // width: '15%',
        value: 'creationDate',
      },
      {
        text: 'Curr DueDate',
        align: 'end',
        // width: '15%',
        value: 'currDueDate',
      },
      {
        text: 'Days Past DDate',
        align: 'end',
        // width: '10%',
        value: 'daysPastDuedate',
      },
      {
        text: 'Due Date Range',
        align: 'start',
        // width: '10%',
        value: 'dueDateAgeRange',
      },
      {
        text: 'Purch Officer',
        align: 'start',
        // width: '10%',
        value: 'purchOfficer',
      },
      {
        text: 'Team Id',
        align: 'start',
        // width: '10%',
        value: 'teamId',
      },
      {
        text: 'Supplier No',
        align: 'start',
        // width: '30%',
        value: 'supplierNo',
      },
      {
        text: 'Supplier Name',
        align: 'start',
        // width: '10%',
        value: 'supplierName',
      },
      {
        text: 'Inspection Code',
        align: 'start',
        // width: '10%',
        value: 'inspectCode',
      },
      {
        text: 'Current Net Price',
        align: 'end',
        // width: '15%',
        value: 'currNetPrI',
      },
      {
        text: 'Inv Ref',
        align: 'start',
        // width: '15%',
        value: 'invoiceRef',
      },
      {
        text: 'Onst Recpt Date',
        align: 'end',
        // width: '10%',
        value: 'onstRcptDate',
      },
      {
        text: 'PRC Code',
        align: 'start',
        // width: '10%',
        value: 'prcCde',
      },
      {
        text: 'Stock Type',
        align: 'start',
        // width: '30%',
        value: 'stockType',
      },
      {
        text: 'ACCC',
        align: 'start',
        // width: '10%',
        value: 'accc',
      },
      {
        text: 'WBS',
        align: 'start',
        // width: '15%',
        value: 'wbs',
      },
      {
        text: 'Fund',
        align: 'start',
        // width: '15%',
        value: 'fund',
      },
      {
        text: 'Del Loc',
        align: 'start',
        // width: '10%',
        value: 'delivLocation221',
      },
      {
        text: 'Date Extract Milis',
        align: 'end',
        // width: '10%',
        value: 'dateExtract',
      },
    ],
    rptSearch: '',
    expAPerc: 0,
    expALoading: false,
    jluCol: [
      {
        unit: 'JLUE',
        color: '#2166ac',
      },
      {
        unit: 'JLUN',
        color: '#060f14',
      },
      {
        unit: 'JLUS',
        color: '#f4a582',
      },
      {
        unit: 'JLUV',
        color: '#92c5de',
      },
      {
        unit: 'JLUSQ',
        color: '#999966',
      },
      {
        unit: 'JLUW',
        color: '#fcee9c',
      },
      {
        unit: 'JLUNQ',
        color: '#d6604d',
      },
    ],
    chartLevel: 'T',
    chartOptions: {
      chart: {
        type: 'column',
        zoomType: 'xy',
      },
      title: {
        text: 'Open Orders',
      },
      subtitle: {
        text: 'Test',
      },
      credits: {
        position: {
          align: 'left',
          x: 20,
          y: -7,
        },
        text: '',
        href: 'webtools.defence.gov.au',
      },
      xAxis: {
        categories: [
        ],
        crosshair: true,
        // type: 'category',
      },
      yAxis: [{
        min: 0,
        title: {
          text: 'Open Purchase Order Lines',
        },
      }, {
        min: 0,
        title: {
          text: 'PO Value',
        },
        opposite: true,
      },
      ],

      series: [
        {
          name: 'Open Orders',
          yAxis: 0,
          data: [null],

        },
        {
          name: 'PO Value',
          yAxis: 1,
          type: 'spline',
          data: [1, 2, 3, 15, 2, null, 2],
          color: '#990033',
        },
      ],
      plotOptions: {
        series: {
          cursor: 'pointer',
          events: {
            click(e) {
              const cL = e.point.cLevel;
              if (cL !== undefined) {
                // console.log('The e ', e);
                if (e.ctrlKey) {
                  const p = {
                    type: 'rptClick',
                    cLevel: cL,
                    unit: e.point.unit,
                    name: e.point.name,
                  };
                  // console.log(`In CtrlClick ${cL}`, p);
                  EventBus.$emit('rptClick', p);
                }
                if (!e.ctrlKey) {
                  // EventBus.$emit('chartClick', e);
                  if (cL === 'T') {
                    const p = {
                      type: 'ddClick',
                      cLevel: cL,
                      unit: e.point.unit,
                      name: e.point.name,
                    };
                    EventBus.$emit('ddClick', p);
                  }
                }
              } // the cL undef end
            },
          },
        },
      },
    },
  }),
  computed: {
    vW: {
      get() {
        return this.$store.state.app.vWH.x * 0.85;
      },
    },
    vW2: {
      get() {
        return this.$store.state.app.vWH.x * 0.95;
      },
    },
    vH: {
      get() {
        return this.$store.state.app.vWH.y * 0.99;
      },
    },
    vHR: {
      get() {
        return this.$store.state.app.vWH.y * 0.6;
      },
    },
    unitList() {
      let u = this.jluCol;
      u = orderBy(u, 'unit', 'asc');
      return u;
    },
    // darkMode() {
    //   return this.$vuetify.theme.isDark;
    // },
    teamsFiltered() {
      const { jlu } = this;
      let t = cloneDeep(this.teams);
      if (jlu !== null && jlu !== undefined && jlu !== '') {
        // console.log('teams pre filter: ', jlu, t);
        t = t.filter((j) => j.unit === jlu);
      }
      t = orderBy(t, 'teamdId', 'asc');
      return t;
    },
    rptMeta() {
      const m = cloneDeep(this.rptDataMeta);
      return m;
    },
    rptTotalItems() {
      const t = this.rptMeta.totalItems;
      return t;
    },

    rptPage: {
      get() {
        const t = this.rptMeta.page;
        return t;
      },
      set(v, ov) {
        if (!isEqual(v, ov)) {
          // eslint-disable-next-line
          // const payload = {
          const page = v;
          // console.log('The page ', v);
          // };
          // console.log('in page set', payload);
          this.rptDataMeta = {
            ...this.rptDataMeta,
            page,
          };
        }
      },
    },
    rptSortBy: {
      get() {
        const t = this.rptMeta.sortBy;
        return t;
      },
      set(v, ov) {
        if (!isEqual(v, ov)) {
          // eslint-disable-next-line
          // const payload = {
          const sortBy = v[0];
          // const sortBy = [{ key: v, asc: false }];
          // console.log('The sortBy ', sortBy);
          const sortDesc = [false];
          const sort = [{ asc: false, key: sortBy }];
          // console.log('in sortBy set', payload);
          this.rptDataMeta = {
            ...this.rptDataMeta,
            sortBy: [sortBy],
            sort,
            sortDesc,
          };
          this.openRptDetails();
          // console.log('The rptMeta ', this.rptDataMeta);
        }
      },
    },
    rptSortByDesc: {
      get() {
        const t = this.rptMeta.sortBy;
        let s = true;
        if (t !== undefined && t.length === 1) {
          s = (t[0].asc);
        }
        return s;
      },
      set(v, ov) {
        if (!isEqual(v, ov)) {
          // eslint-disable-next-line
          // console.log('v then old', v, ov)
          // const payload = {
          const sortByD = v[0];
          const ascV = !sortByD;
          // console.log('The sortByDesc ', sortByD);
          const sortK = this.rptMeta.sort[0].key;
          // console.log('The sortK from desc ', sortK);
          const sort = [{ asc: ascV, key: sortK }];
          const sortBy = [sortK];
          const sortDesc = [sortByD];

          this.rptDataMeta = {
            ...this.rptDataMeta,
            sortBy,
            sort,
            sortDesc,
          };
          this.openRptDetails();

          // };
          // console.log('in sortBy set', p);
          // this.rptDataMeta = {
          //   ...this.rptDataMeta,
          //   sortBy,
          // };
        }
      },
    },
  },
  watch: {
    rptPage: {
      deep: true,
      handler(nv, ov) {
        if (nv !== ov) {
          // console.log('the page has changed', nv);
          this.openRptDetails();
        }
      },
    },
    // rptSortBy: {
    //   deep: true,
    //   handler(nv, ov) {
    //     if (nv !== ov) {
    //       // console.log('the page has changed', nv);
    //       this.openRptDetails();
    //     }
    //   },
    // },
    // rptSortDescy: {
    //   deep: true,
    //   handler(nv, ov) {
    //     if (nv !== ov) {
    //       // console.log('the page has changed', nv);
    //       this.openRptDetails();
    //     }
    //   },
    // },
    rptSearch: {
      handler(nv, ov) {
        if (nv !== ov) {
          // console.log('the rpt Search has changed', nv);
          this.openRptDetails();
        }
      },
    },
    actionCall: {
      handler(v) {
        if (v !== undefined && v !== '') {
          // console.log('actionCall watcher', v);
          if (v !== 'rptClick') {
            // console.log('not rptClick watcher', v);
            const fT = cloneDeep(this.focusType);
            this.$emit('clrAC');
            if (fT === 'DST') {
              this.formdataDST();
            } else {
              this.formdataRNG();
            }
          }
          if (v === 'rptClick') {
            this.openRptDetails();
            this.$emit('clrAC');
          }
        }
      },
      immediate: true,
    },
    jlu: {
      handler(v) {
        this.teamSel = [];
        this.focusType = (v !== undefined && v !== null && v !== '') ? 'RNG' : 'DST';
        this.$emit('unitChange');
        this.refreshTable();
        this.grabUnitTeams();
      },
      immediate: true,
    },
    fmsIncl: {
      handler() {
        this.$emit('fmsChange');
        this.refreshTable();
      },
      immediate: true,
    },
    teamSel: {
      handler() {
        this.$emit('teamChange');
        this.refreshTable();
      },
      immediate: true,
    },
  },
  mounted() {
    this.refreshTable();
    this.grabUnitTeams();
  },
  methods: {
    exportAll() {
      this.expALoading = true;
      const url = '/report-all-p-o-data';
      // const callBackXls = this.callBackXls();
      let d = new Date();
      d = dateFyymmdd(d);
      const options = {
        ...this.rptDataMeta,
        itemsPerPage: 750,
        title: `${d} - All Open PO Data`,
        headers: this.headersRptDL,
        params: { filter: [] },
        callback: (({ meta }) => {
          let p = meta.percentageComplete;
          p = p.toFixed(2);
          this.expAPerc = p;
          if (meta.percentageComplete > 99.9) {
            this.expALoading = false;
          }
          // console.log('this', meta.percentageComplete);
        }),
      };
      // console.log('the full export', url, options);
      exportBulkExcel(url, options);
    },
    download() {
      const url = '/report-p-o-data';
      this.dlProcess = true;
      let d = new Date();
      d = dateFyymmdd(d);
      const tC = this.topClick;
      const u = cloneDeep(this.unit);
      const filt = [];
      let sear = this.rptSearch;
      if (sear !== undefined && sear !== null && sear !== '') {
        sear = `%${this.rptSearch}%`;
        const searElm = { key: 'searchField', like: sear };
        filt.push(searElm);
      }
      let n = this.name;
      const fT = cloneDeep(this.focusType);
      // console.log('the focus Type', fT);
      if (fT === 'RNG') {
        if (tC === null) {
          const rngElm = { key: 'dueDateAgeRange', equal: n };
          filt.push(rngElm);
        } else {
          const rngElm = { key: 'dueDateAgeRange', equal: tC };
          filt.push(rngElm);
        }
      }

      const nm = parseFloat(n);
      n = (nm === 'NaN') ? n : n.toString();
      const cL = cloneDeep(this.cL);

      if (cL === 'T') {
        const filElm = { key: 'unit', equal: u };
        filt.push(filElm);
        // console.log('the top', tC);
      }
      if (cL === 'D') {
        let filElm = { key: 'unit', equal: u };
        filt.push(filElm);
        filElm = { key: 'dstrctCode', equal: n, parse: false };
        filt.push(filElm);
        // console.log('the d', tC);
      }

      // if (fT==='')
      let tSarr = '';
      const tS = cloneDeep(this.teamSel);
      if (tS !== undefined && tS.length > 0) {
        tSarr = tS;
      }
      if (tSarr !== '') {
        const teamElm = { key: 'teamId', in: tSarr };
        filt.push(teamElm);
        // console.log('the team', teamElm);
      }

      const f = this.fmsIncl;
      let fmsFiltElm = '';
      switch (f) {
        case 'exFMS':
          fmsFiltElm = { key: 'supplierNo', notEqualTo: 'FMS' };
          break;
        case 'incFMS':
          fmsFiltElm = '';
          break;
        case 'justFMS':
          fmsFiltElm = { key: 'supplierNo', equal: 'FMS' };
          break;
        default:
          fmsFiltElm = '';
      }
      if (fmsFiltElm !== '') {
        filt.push(fmsFiltElm);
      }

      const options = {
        ...this.rptDataMeta,
        itemsPerPage: 500,
        title: `${d} - Open PO `,
        headers: this.headersRptDL,
        params: { filter: filt },
        callback: (({ meta }) => {
          let p = meta.percentageComplete;
          p = p.toFixed(2);
          this.rptPerc = p;
          if (meta.percentageComplete > 99.9) {
            this.dlProcess = false;
          }
          // console.log('this', meta.percentageComplete);
        }),
      };
      //   rptPerc: 0,
      // rptLoading: false,
      // console.log('the download', url, options);
      exportBulkExcel(url, options);
    },
    buildRptTitle() {
      let j = cloneDeep(this.name);
      const cL = cloneDeep(this.cL);
      let tC = cloneDeep(this.topClick);
      if (tC !== undefined && tC !== null) {
        const tClth = tC.length;
        tC = tC.substring(2, tClth);
      }
      let r = '';
      let d = '';
      const fT = cloneDeep(this.focusType);
      if (cL === 'T') {
        if (fT === 'RNG') {
          // console.log('In top with RNG');
          j = this.unit;
          let ddr = this.name;
          if (ddr !== undefined && ddr !== null) {
            const ddrlth = ddr.length;
            ddr = ddr.substring(2, ddrlth);
          }
          r = `, with a Due Date Range of ${ddr}`;
        }
      }
      let tStxt = '';
      const tS = cloneDeep(this.teamSel);
      if (tS !== undefined && tS.length > 0) {
        const tSprep = JSON.stringify(tS);
        const tSquote = tSprep.replace(/"/g, '\'');
        tStxt = tSquote.replace(/\[|\]/g, (m) => {
          const replacements = { '[': '(', ']': ')' }; return replacements[m];
        });
        if (tS.length === 1) {
          tStxt = ` - team ${tStxt}`;
        } else {
          tStxt = ` - teams ${tStxt}`;
        }
      }
      const { fmsIncl } = this;
      let fmsTxt = '';
      switch (fmsIncl) {
        case 'exFMS':
          fmsTxt = ' (excluding FMS)';
          break;
        case 'incFMS':
          fmsTxt = '';
          break;
        case 'justFMS':
          fmsTxt = '(just FMS)';
          break;
        default:
      }
      if (cL === 'D') {
        if (fT === 'RNG') {
          j = this.unit;
          r = `, with a Due Date Range of ${tC}`;
          d = ` at ${this.name}`;
          // console.log('in D and RNG ', j, r, d);
        }
        if (fT === 'DST') {
          j = this.unit;
          d = ` at ${this.name}`;
          // console.log('in D and DST ', j, d);
        }
      }
      const t = `Open Purchase Orders ${fmsTxt} for ${j}${d}${tStxt} ${r}`;
      this.rptTitle = t;
    },
    async openRptDetails() {
      // console.log('running the rpt');
      const filt = [];
      let sear = this.rptSearch;
      if (sear !== undefined && sear !== null && sear !== '') {
        sear = `%${this.rptSearch}%`;
        const searElm = { key: 'searchField', like: sear };
        filt.push(searElm);
      }
      // const sear = '%pliers%';
      // const searElm = { key: 'searchField', like: sear };
      // filt.push(searElm);
      const tC = this.topClick;
      this.rptLoading = true;
      const u = cloneDeep(this.unit);

      let n = this.name;
      const fT = cloneDeep(this.focusType);
      // console.log('the focus Type', fT);
      if (fT === 'RNG') {
        if (tC === null) {
          const rngElm = { key: 'dueDateAgeRange', equal: n };
          filt.push(rngElm);
        } else {
          const rngElm = { key: 'dueDateAgeRange', equal: tC };
          filt.push(rngElm);
        }
      }

      const nm = parseFloat(n);
      n = (nm === 'NaN') ? n : n.toString();
      const cL = cloneDeep(this.cL);

      if (cL === 'T') {
        const filElm = { key: 'unit', equal: u };
        filt.push(filElm);
        // console.log('the top', tC);
      }
      if (cL === 'D') {
        let filElm = { key: 'unit', equal: u };
        filt.push(filElm);
        filElm = { key: 'dstrctCode', equal: n, parse: false };
        filt.push(filElm);
        // console.log('the d', tC);
      }

      // if (fT==='')
      let tSarr = '';
      const tS = cloneDeep(this.teamSel);
      if (tS !== undefined && tS.length > 0) {
        tSarr = tS;
      }
      if (tSarr !== '') {
        const teamElm = { key: 'teamId', in: tSarr };
        filt.push(teamElm);
        // console.log('the team', teamElm);
      }

      const rdm = this.rptDataMeta;
      const { jlu } = this;
      const f = this.fmsIncl;
      let fmsFiltElm = '';
      switch (f) {
        case 'exFMS':
          fmsFiltElm = { key: 'supplierNo', notEqualTo: 'FMS' };
          break;
        case 'incFMS':
          fmsFiltElm = '';
          break;
        case 'justFMS':
          fmsFiltElm = { key: 'supplierNo', equal: 'FMS' };
          break;
        default:
          fmsFiltElm = '';
      }
      if (fmsFiltElm !== '') {
        filt.push(fmsFiltElm);
      }

      const payload = {
        ...rdm,
        focusType: fT,
        // chartLevel: cL,
        jlu,
        filter: filt,
        // unit: u,
        // entity: n,
        // teamSel: tSarr,
        fmsIncl: f,
        // eslint-disable-next-line
            // filter: [{ key: 'jlu', equals: jlu },  { key: 'fmsIncl', equals: f }],
      };
      // console.log('Gonna open Report', payload);
      const response = await get('/report-p-o-data', { params: payload });
      if (response.status === 200) {
        // console.log('the rtn', response.data);
        this.rptDataSet = response.data;
        this.rptDataMeta = {
          ...this.rptDataMeta,
          ...response.meta,
        };
        this.rptLoading = false;
        this.$nextTick(() => {
          this.buildRptTitle();
        });
        this.opnRptD = true;
      }
      // console.log('Got  Report meta', this.rptDataMeta);
    },
    closeRpt() {
      this.opnRptD = false;
      this.rptTitle = '';

      this.rptDataSet = [];
    },
    async refreshTable() {
      const fT = cloneDeep(this.focusType);
      let tStxt = '';
      const tS = cloneDeep(this.teamSel);
      if (tS !== undefined && tS.length > 0) {
        const tSprep = JSON.stringify(tS);
        const tSquote = tSprep.replace(/"/g, '\'');
        tStxt = tSquote.replace(/\[|\]/g, (m) => {
          const replacements = { '[': '(', ']': ')' }; return replacements[m];
        });
      }
      const { jlu } = this;
      const f = this.fmsIncl;
      const payload = {
        totalItems: 0,
        itemsPerPage: 1000,
        jlu,
        teamSel: tStxt,
        fmsIncl: f,
        sort: [{ asc: true, key: 'unit' }],
        page: 1,
      };

      const response = await get('/po-data', { params: payload });
      if (response.status === 200) {
        this.dataSet = response.data;
        if (fT === 'DST') {
          this.formdataDST();
        } else {
          this.formdataRNG();
        }
        this.gTg = true;
      }
    },
    async grabUnitTeams() {
      const filt = [];
      const { jlu } = this;
      if (jlu !== undefined && jlu !== null && jlu !== '') {
        const fElm = { key: 'unit', equals: jlu };
        filt.push(fElm);
      }

      const payload = {
        totalItems: 0,
        itemsPerPage: 1000,
        filter: filt,
        sort: [{ asc: true, key: 'teamId' }],
        page: 1,
      };
      const response = await get('/unit-teams', { params: payload });
      let t = [];

      if (response.status === 200) {
        t = response.data;
        t = orderBy(t, 'teamId', 'asc');
        this.teams = t;
      }
    },

    applySat(sat, hex) {
      const hash = hex.substring(0, 1) === '#';

      const hexN = (hash ? hex.substring(1) : hex).split('');

      const long = hexN.length > 3;
      const rgb = [];
      let i = 0;
      const len = 3;

      rgb.push(hexN.shift() + (long ? hexN.shift() : ''));
      rgb.push(hexN.shift() + (long ? hexN.shift() : ''));
      rgb.push(hexN.shift() + (long ? hexN.shift() : ''));
      // eslint-disable-next-line
      for (; i < len; i++) {
        if (!long) {
          rgb[i] += rgb[i];
        }
        // eslint-disable-next-line
        rgb[i] = Math.round(parseInt(rgb[i], 16) / 100 * sat).toString(16);

        rgb[i] += rgb[i].length === 1 ? rgb[i] : '';
      }

      return (hash ? '#' : '') + rgb.join('');
    },
    formdataDST() {
      this.showChart = false;
      // eslint-disable-next-line
      const  cL = this.cL;
      const Arr = cloneDeep(this.dataSet);
      let t = 'Joint Logistics Command - Supply Chain Branch dated';
      if (Arr !== undefined && Arr.length > 0) {
        let dte = Arr[0].dateExtract;

        if (dte !== undefined) {
          let d = new Date(dte);
          const z = d.getTimezoneOffset() * 60 * 1000;
          // console.log('The z', z);
          d -= z;
          // d = d.toString().slice(0, 10);
          // d = new Date(d).toISOString().slice(0, 10);
          dte = dateOnly(d);
          t = `Joint Logistics Command - Supply Chain Branch dated ${dte}`;
        }
      }
      const seriesD1 = [];
      const seriesD0 = [];

      // let dcn = '';
      const jColArr = cloneDeep(this.jluCol);
      // eslint-disable-next-line

      let unit = Arr.map((u) => u.unit);
      // console.log('a post map', unit);
      if (unit !== undefined && unit.length > 0) {
        unit = uniqBy(unit, (i) => i);
        unit = unit.sort();

        if (cL === 'T') {
          this.chartOptions.xAxis.categories = unit;

          unit.forEach((j) => {
            const jluC = Arr.filter((p) => p.unit === j)
              .map((c) => c.pOCnt)
              .reduce((acc, s) => acc + s, 0);
            const jcol = jColArr.filter((c) => c.unit === j);
            const elm = {
              name: j,
              y: jluC,
              color: jcol[0].color,
              cLevel: cL,
              unit: j,
            };
            seriesD0.push(elm);
            const jluV = Arr.filter((p) => p.unit === j)
              .map((c) => c.pOVal)
              .reduce((acc, s) => acc + s, 0);
            let jluVN = jluV;
            jluVN = jluVN.toFixed(0);
            jluVN = Number(jluVN);
            // console.log('the v ', jluVN);
            // const valElm = {
            //   name: j,
            //   y: jluVN,
            // };
            seriesD1.push(jluVN);
          });
        }
        if (cL === 'D') {
          // this.chartOptions.xAxis.categories = unit;
          const u = this.unit;
          // const n = this.name;
          // console.log(`fomrdata for DST u-${u} n-${n}`);
          const jluDC = Arr.filter((d) => d.unit === u);
          let dCode = jluDC.map((cx) => cx.dstrctCode);
          dCode = uniqBy(dCode, (dd) => dd);
          dCode = orderBy(dCode, '', 'asc');
          this.chartOptions.xAxis.categories = dCode;
          const nDC = 100 / dCode.length;
          let ucol = jColArr.filter((c) => c.unit === u)[0].color;
          dCode.forEach((dc) => {
          // dcn = dc.dstrctCode;
            const dcC = jluDC.filter((x) => x.dstrctCode === dc)
              .map((c) => c.pOCnt)
              .reduce((acc, s) => acc + s, 0);
            // const arrElm = [dc, dcC];
            const elm = {
              name: dc,
              y: dcC,
              color: ucol,
              cLevel: cL,
              unit: u,
            };
            ucol = this.applySat(nDC, ucol);
            seriesD0.push(elm);
            const dcV = jluDC.filter((p) => p.dstrctCode === dc)
              .map((c) => c.pOVal)
              .reduce((acc, s) => acc + s, 0);
            let dcVN = dcV;
            dcVN = dcVN.toFixed(0);
            dcVN = Number(dcVN);
            // console.log('the v ', jluVN);
            const valElm = {
              name: dc,
              y: dcVN,
            };
            seriesD1.push(valElm);
          });
          // console.log('D data-', seriesD0);
        }
        // console.log('The series1', seriesD1);
        this.chartOptions.series[0].data = seriesD0;
        this.chartOptions.series[1].data = seriesD1;
        this.chartOptions.subtitle.text = 'By Unit then District';
        // eslint-disable-next-line
        // this.chartOptions.drilldown.series = seriesDrillDown;
      }

      this.chartOptions.credits.text = t;
      this.showChart = true;
    },
    formdataRNG() {
      this.showChart = false;
      // eslint-disable-next-line
      const u = cloneDeep(this.jlu);
      const Arr = cloneDeep(this.dataSet);
      const { cL } = this;
      const tC = this.topClick;
      let t = 'Joint Logistics Command - Supply Chain Branch dated';
      if (Arr !== undefined && Arr.length > 0) {
        let dte = Arr[0].dateExtract;
        // console.log('the date', dte);

        if (dte !== undefined) {
          let d = new Date(dte);
          const z = d.getTimezoneOffset() * 60 * 1000;
          // console.log('The z', z);
          d -= z;
          // d = d.toString().slice(0, 10);
          // d = new Date(d).toISOString().slice(0, 10);
          dte = dateOnly(d);
          t = `Joint Logistics Command - Supply Chain Branch dated ${dte}`;
        }
      }
      // console.log('the level', cL);

      const seriesD1 = [];
      const seriesD0 = [];

      // let dcn = '';
      const jColArr = cloneDeep(this.jluCol);
      // eslint-disable-next-line

      let rng = Arr.map((rx) => rx.dueDateAgeRange);
      // console.log('a post map', rng);
      if (rng !== undefined && rng.length > 0) {
        rng = uniqBy(rng, (i) => i);
        rng = rng.sort();

        if (cL === 'T') {
          // console.log(`Doing Top in Range - ${tC}`);
          this.chartOptions.xAxis.categories = rng;

          rng.forEach((r) => {
            const rngD = Arr.filter((p) => p.dueDateAgeRange === r)
              .map((c) => c.pOCnt)
              .reduce((acc, s) => acc + s, 0);
            const jcol = jColArr.filter((c) => c.unit === u);
            const elm = {
              name: r,
              y: rngD,
              color: jcol[0].color,
              cLevel: cL,
              unit: u,
            };
            seriesD0.push(elm);
            const dataV = Arr.filter((p) => p.dueDateAgeRange === r)
              .map((c) => c.pOVal)
              .reduce((acc, s) => acc + s, 0);
            let dataVN = dataV;
            dataVN = dataVN.toFixed(0);
            dataVN = Number(dataVN);
            // console.log('the v ', jluVN);
            // const valElm = {
            //   name: j,
            //   y: jluVN,
            // };
            seriesD1.push(dataVN);
          });
        }
        if (cL === 'D') {
          // this.chartOptions.xAxis.categories = unit;
          const uD = this.unit;
          // console.log(`${cL} - ${uD} - ${tC}`);
          // console.log(`fomrdata for DST u-${u} n-${n}`);
          const jluDC = Arr.filter((d) => d.unit === uD && d.dueDateAgeRange === tC);
          let dCode = jluDC.map((cx) => cx.dstrctCode);
          dCode = uniqBy(dCode, (dd) => dd);
          dCode = orderBy(dCode, '', 'asc');
          this.chartOptions.xAxis.categories = dCode;
          const nDC = 100 / dCode.length;
          let ucol = jColArr.filter((c) => c.unit === u)[0].color;
          dCode.forEach((dc) => {
          // dcn = dc.dstrctCode;
            const dcC = jluDC.filter((x) => x.dstrctCode === dc)
              .map((c) => c.pOCnt)
              .reduce((acc, s) => acc + s, 0);
            // const arrElm = [dc, dcC];
            const elm = {
              name: dc,
              y: dcC,
              color: ucol,
              cLevel: cL,
              unit: u,
            };
            ucol = this.applySat(nDC, ucol);
            seriesD0.push(elm);
            const dcV = jluDC.filter((p) => p.dstrctCode === dc)
              .map((c) => c.pOVal)
              .reduce((acc, s) => acc + s, 0);
            let dcVN = dcV;
            dcVN = dcVN.toFixed(0);
            dcVN = Number(dcVN);
            // console.log('the v ', jluVN);
            const valElm = {
              name: dc,
              y: dcVN,
            };
            seriesD1.push(valElm);
          });
          // console.log('D data-', seriesD0);
        }
        // console.log('The series0', seriesD0);
        this.chartOptions.series[0].data = seriesD0;
        this.chartOptions.series[1].data = seriesD1;
        // eslint-disable-next-line
        // this.chartOptions.drilldown.series = seriesDrillDown;

      }

      this.chartOptions.credits.text = t;
      this.chartOptions.subtitle.text = `Focused on ${u}, Age of PO then District `;
      // const s0 = Arr.map((a) => a.m3_6);
      // const s1 = Arr.map((a) => a.uniqCust);
      // const s2 = Arr.map((a) => a.ucSubmit);
      // const nH = this.applySat(50, '#fed');
      // console.log('ff0000', nH);
      // console.log('axis', axis);
      // const axis = filter(Arr, o => o.axisDate !== '');
      // const b = Arr.AxisDate.join();

      // this.chartOptions.series[0].data = s0;
      // this.chartOptions.series[1].data = s1;
      // this.chartOptions.series[2].data = s2;

      // setTimeout(this.showChart = true, 500);

      // const u = cloneDeep(this.getUrlB);

      // this.chartOptions.credits.href = 'https://testy.com';

      // this.showChart = true;
      this.showChart = true;
    },
    clickBack() {
      this.$emit('clickBack');
    },
  },
};
</script>
